#ifndef _STATUS_H_
#define _STATUS_H_
#include "config.h"

/**
 * Allocate a status window at the bottom of the terminal
 *
 * Saves the status window into the `*conf` parameter.
 */
void init_status(struct config *conf);

/**
 * Set the message currently displayed in the status window.
 */
void update_status(struct config *conf, char *s);

/**
 * Set the status to prompt for a Molerat URL. The raw string recieved will be.
 * placed in `*conf`
 */
void prompt_status_url(struct config *conf);

/**
 * Same as `update_status` but signify error.
 */
void error_status(struct config *conf, char *s);
#endif
